<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:redirect="http://xml.apache.org/xalan/redirect"
    xmlns:sablecc="sablecc-extension"
    extension-element-prefixes="redirect sablecc">

  <xsl:template name="make_analysis">

    <redirect:write select="concat($basedir, '/analysis.cs')" mkdirs="true">
/* This file was generated by SableCC (http://www.sablecc.org/). */

using System;
using System.Collections;
using <xsl:value-of select="/parser/@package"/>.node;

namespace <xsl:value-of select="/parser/@package"/>.analysis {

    <!-- Generate the Analysis class -->

public interface Analysis : Switch
{
    Object GetIn(Node node);
    void SetIn(Node node, Object inobj);
    Object GetOut(Node node);
    void SetOut(Node node, Object outobj);

    void CaseStart(Start node);
<xsl:for-each select="productions/production/alt">
    void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node);
</xsl:for-each>

<xsl:for-each select="tokens/token">
    void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node);
</xsl:for-each>
    void CaseEOF(EOF node);
}

    <!-- Generate the AnalysisAdapter class -->

public class AnalysisAdapter : Analysis
{
    private Hashtable inhash;
    private Hashtable outhash;

    public virtual Object GetIn(Node node)
    {
        if(inhash == null)
        {
            return null;
        }

        return inhash[node];
    }

    public virtual void SetIn(Node node, Object inobj)
    {
        if(this.inhash == null)
        {
            this.inhash = new Hashtable(1);
        }

        if(inobj != null)
        {
            this.inhash[node] = inobj;
        }
        else
        {
            this.inhash.Remove(node);
        }
    }
    public virtual Object GetOut(Node node)
    {
        if(outhash == null)
        {
            return null;
        }

        return outhash[node];
    }

    public virtual void SetOut(Node node, Object outobj)
    {
        if(this.outhash == null)
        {
            this.outhash = new Hashtable(1);
        }

        if(outobj != null)
        {
            this.outhash[node] = outobj;
        }
        else
        {
            this.outhash.Remove(node);
        }
    }
    public virtual void CaseStart(Start node)
    {
        DefaultCase(node);
    }

<xsl:for-each select="productions/production/alt">
    public virtual void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultCase(node);
    }
</xsl:for-each>

<xsl:for-each select="tokens/token">
    public virtual void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultCase(node);
    }
</xsl:for-each>

    public virtual void CaseEOF(EOF node)
    {
        DefaultCase(node);
    }

    public virtual void DefaultCase(Node node)
    {
    }
}

    <!-- Generate the DepthFirstAdapter class -->

public class DepthFirstAdapter : AnalysisAdapter
{
    public virtual void InStart(Start node)
    {
        DefaultIn(node);
    }

    public virtual void OutStart(Start node)
    {
        DefaultOut(node);
    }

    public virtual void DefaultIn(Node node)
    {
    }

    public virtual void DefaultOut(Node node)
    {
    }

    public override void CaseStart(Start node)
    {
        InStart(node);
        node.Get<xsl:value-of select="/parser/productions/production/@ename"/>().Apply(this);
        node.GetEOF().Apply(this);
        OutStart(node);
    }

<xsl:for-each select="productions/production/alt">
    public virtual void In<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultIn(node);
    }

    public virtual void Out<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultOut(node);
    }

    public override void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        In<xsl:value-of select="@ename"/>(node);
  <xsl:for-each select="elem">
    <xsl:if test="@is_list">
        {
            Object[] temp = new Object[node.Get<xsl:value-of select="@ename"/>().Count];
            node.Get<xsl:value-of select="@ename"/>().CopyTo(temp, 0);
            for(int i = 0; i &lt; temp.Length; i++)
            {
                ((<xsl:value-of select="@etype"/>) temp[i]).Apply(this);
            }
        }
    </xsl:if>
    <xsl:if test="not(@is_list)">
        if(node.Get<xsl:value-of select="@ename"/>() != null)
        {
            node.Get<xsl:value-of select="@ename"/>().Apply(this);
        }
    </xsl:if>
  </xsl:for-each>
        Out<xsl:value-of select="@ename"/>(node);
    }
</xsl:for-each>
}

    <!-- Generate the ReverseDepthFirstAdapter class -->

public class ReverseDepthFirstAdapter : AnalysisAdapter
{
    public virtual void InStart(Start node)
    {
        DefaultIn(node);
    }

    public virtual void OutStart(Start node)
    {
        DefaultOut(node);
    }

    public virtual void DefaultIn(Node node)
    {
    }

    public virtual void DefaultOut(Node node)
    {
    }

    public override void CaseStart(Start node)
    {
        InStart(node);
        node.GetEOF().Apply(this);
        node.Get<xsl:value-of select="/parser/productions/production/@ename"/>().Apply(this);
        OutStart(node);
    }

<xsl:for-each select="productions/production/alt">
    public virtual void In<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultIn(node);
    }

    public virtual void Out<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        DefaultOut(node);
    }

    public override void Case<xsl:value-of select="@ename"/>(<xsl:value-of select="@ename"/> node)
    {
        In<xsl:value-of select="@ename"/>(node);
  <xsl:for-each select="elem">
    <xsl:sort select="position()" data-type="number" order="descending"/>
    <xsl:if test="@is_list">
        {
            Object[] temp = new Object[node.Get<xsl:value-of select="@ename"/>().Count];
            node.Get<xsl:value-of select="@ename"/>().CopyTo(temp, 0);
            for(int i = temp.Length - 1; i &gt;= 0; i--)
            {
                ((<xsl:value-of select="@etype"/>) temp[i]).Apply(this);
            }
        }
    </xsl:if>
    <xsl:if test="not(@is_list)">
        if(node.Get<xsl:value-of select="@ename"/>() != null)
        {
            node.Get<xsl:value-of select="@ename"/>().Apply(this);
        }
    </xsl:if>
  </xsl:for-each>
        Out<xsl:value-of select="@ename"/>(node);
    }
</xsl:for-each>
}
}
    </redirect:write>
  </xsl:template>

</xsl:stylesheet>

