<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:redirect="http://xml.apache.org/xalan/redirect"
    xmlns:sablecc="sablecc-extension"
    extension-element-prefixes="redirect sablecc">

  <xsl:template name="make_tokens">

    <redirect:write select="concat($basedir,'/tokens.cs')" mkdirs="true">
/* This file was generated by SableCC (http://www.sablecc.org/). */

using System;
using System.Collections;
using System.Text;

using  <xsl:value-of select="/parser/@package"/>.analysis;

namespace <xsl:value-of select="/parser/@package"/>.node {

    <!-- generate all fixed token classes -->
    <xsl:for-each select="tokens/token[@value]">

public sealed class <xsl:value-of select="@ename"/> : Token
{
    public <xsl:value-of select="@ename"/>()
    {
        base.Text = "<xsl:value-of select="sablecc:escape_string_literal(string(@value))"/>";
    }

    public <xsl:value-of select="@ename"/>(int line, int pos)
    {
        base.Text = "<xsl:value-of select="sablecc:escape_string_literal(string(@value))"/>";
        Line = line;
        Pos = pos;
    }

    public override Object Clone()
    {
      return new <xsl:value-of select="@ename"/>(Line, Pos);
    }

    public override void Apply(Switch sw)
    {
        ((Analysis) sw).Case<xsl:value-of select="@ename"/>(this);
    }

    public override string Text
    {
      get { return base.Text; }
      set { throw new ApplicationException("Cannot change <xsl:value-of select="@ename"/> text."); }
    }
}
    </xsl:for-each> <!-- done/generate all fixed token classes -->

    <!-- generate all variable token classes -->
    <xsl:for-each select="tokens/token[not(@value)]">

public sealed class <xsl:value-of select="@ename"/> : Token
{
    public <xsl:value-of select="@ename"/>(string text)
    {
        Text = text;
    }

    public <xsl:value-of select="@ename"/>(string text, int line, int pos)
    {
        Text = text;
        Line = line;
        Pos = pos;
    }

    public override Object Clone()
    {
      return new <xsl:value-of select="@ename"/>(Text, Line, Pos);
    }

    public override void Apply(Switch sw)
    {
        ((Analysis) sw).Case<xsl:value-of select="@ename"/>(this);
    }
}
    </xsl:for-each> <!-- done/generate all variable token classes -->

    <!-- Generate the Token class -->
public abstract class Token : Node
{
    private string text;
    private int line;
    private int pos;

    public virtual string Text
    {
      get { return text; }
      set { text = value; }
    }

    public int Line
    {
      get { return line; }
      set { line = value; }
    }

    public int Pos
    {
      get { return pos; }
      set { pos = value; }
    }

    public override string ToString()
    {
        return text + " ";
    }

    internal override void RemoveChild(Node child)
    {
    }

    internal override void ReplaceChild(Node oldChild, Node newChild)
    {
    }
}

    <!-- Generate the EOF class -->

public sealed class EOF : Token
{
    public EOF()
    {
        Text = "";
    }

    public EOF(int line, int pos)
    {
        Text = "";
        Line = line;
        Pos = pos;
    }

    public override Object Clone()
    {
        return new EOF(Line, Pos);
    }

    public override void Apply(Switch sw)
    {
        ((Analysis) sw).CaseEOF(this);
    }
}
}
    </redirect:write>
  </xsl:template>

</xsl:stylesheet>

